#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import signal
import math
import os
import subprocess
from time import sleep
import GYRO

track = 0
volume = 0
status = True

p_track = track
p_status = status

y_ac_count = 0
z_ac_count = 0
z_gy_count = 0

def strstdout(data):
	out ="echo " + str(data)
	subprocess.call(out.strip().split(" "))


if __name__ == "__main__":
	signal.signal(signal.SIGINT,signal.SIG_DFL)
	
	strstdout(os.getpid())
	gyro = GYRO.GYRO()
	sleep(0.1)
	gyro.sensor_calib()
	strstdout("t:" + str(track))
	strstdout("s:" + str(status))
	strstdout("start")

	while True:
		val = gyro.get_sense_value()

		if abs(val[5]) < 20:
			if abs(val[1]) > 0.30:
				y_ac_count += 10*val[1] - (val[1]/abs(val[1]))
			else:
				track = 0
				y_ac_count = 0

		if abs(val[1]) < 0.30:
			if abs(val[5]) > 20:
				z_gy_count += val[5]/20
			else:
				z_gy_count = 0

		if abs(val[1]) < 0.30:
			if val[2] < 1 :
				z_ac_count += 10 - 10*val[2]
			else :
				z_ac_count = 0
		else:
			z_ac_count = 0

		if y_ac_count > 20:
			track += 1
			y_ac_count =-10
		elif y_ac_count < -20:
			track -= 1
			y_ac_count = -10

		if z_gy_count > 10:
			volume = -1
			z_gy_count = 0
		elif z_gy_count < -10:
			volume = 1
			z_gy_count = 0

		if z_ac_count > 5:
			if status == False:
				status = True	
			else :
				status = False
			z_ac_count = -50

		if track == 3:
			track = 0
		if track == -1:
			track = 2

		if track != p_track:
			strstdout("t:" + str(track))
			p_track = track
			
		if volume != 0:
			strstdout("v:" + str(volume))
			volume = 0

		if status != p_status:
			strstdout("s:" + str(status))
			p_status = status

		sleep(0.05)
